/*
Copyright (c) 2005-2009 TeamF1, Inc.
All rights reserved.
*/

function ipAddrOctetCheck (ipObjArr)
	{
	for (var i = 0; i < ipObjArr.length; i++)
		{
		var octet = ipObjArr[i];
		if (octet == "" || isNaN (octet))
			return false;
		if (i == 0)
			{
			if (parseInt (octet, 10) < 1 || parseInt (octet, 10) > 223)
				return false;
			}
		else if (i == 3)
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 254)
				return false;
			}
		else
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 255)
				return false;
			}		
		}
	return true;
	}

function nextActiveFieldGet (srcObj)
    {
    if (!srcObj) return null;
    if ((srcObj.name).indexOf("ip4.") == 0)    return null;
    var currObj = null;
    var formObj = srcObj.form;
    var nFormElmnts = formObj.elements.length;
    for (var i = 0; i < nFormElmnts; i++)
        {
        currObj = formObj.elements[i];
        if (currObj.type != "hidden" &&
            !currObj.disabled)
            {
            if (srcObj == currObj && i != (nFormElmnts - 1))
               return formObj.elements[i+1]
           }
        }
    return null;
    }
 
/* 
* minVal & maxVal are the min and max values for the specified octet.
* errStr is the message that need to be displayed when the specified octet fails
* to statisfy specified values.
*/
function ipv4ByteCheck (eventObj, srcObj, minVal, maxVal, prefixStr, suffixStr)
    {
    if (!eventObj || !srcObj)
         return false;
    var charUniCode = eventObj.charCode ? eventObj.charCode : eventObj.keyCode;
    /* process only 'tab', '.' keys and space*/
    if (charUniCode != 9 &&
        charUniCode != 110 && charUniCode != 190 &&
        charUniCode != 32)
         return true;
         
    var value = srcObj.value;
    /* return false if field value is empty */
    if (value.length == 0)
        return true;
    if (!minVal) minVal = 0;
    if (!maxVal) maxVal = 255;
    if (!prefixStr) prefixStr = 'Invalid IP address.';
    if (!suffixStr) suffixStr = 'for each octet.';
    if (!(numericValueRangeCheck (srcObj, '', '', minVal, maxVal, true, prefixStr, suffixStr)))
         {
         srcObj.focus ();
         return false;
         }
    /* move focus to next active object if '.' is pressed */
    if (charUniCode == 110 || charUniCode == 190 ||
        charUniCode == 32)
        {
        var nextObj = nextActiveFieldGet (srcObj);
        if (nextObj)
            {
            nextObj.focus ();
            nextObj.select ();
            }
        return false;
        }
   
    return true;
    }
 
function ipv4AddrsCheck (ipv4TblIdArr)
    {
    for (var i = 0; i < ipv4TblIdArr.length; ++i)
        {
        var result = false;
        var strArr = ipv4TblIdArr[i].split(",");
        if (strArr.length > 1)
            {
            /*
            * the string will be in the following format.
            * strArr[0] - IPV4 address table ID.
            * strArr[1] - IPV4 address address type (IP,SM,NID).
            * strArr[2] - optional/mandatory (true/false).
            * strArr[3] - prefix error string.
            * strArr[4] - suffix error string.
            */
            result = ipv4AddrOctetsValidate (strArr[0], strArr[1],
                                             (strArr[2] == 'true'),
                                             true, strArr[3], strArr[4], true);
            }
        else
            result = ipv4AddrOctetsValidate (strArr[0], 'IP', false);
        if (!result) return false;
        }
     }
function ipv4AddrOctetsValidate 
    (ipv4TblId, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
    {
    if (!ipv4TblId) return false;
    var obj = document.getElementById(ipv4TblId);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    if (!ipv4AddrTypeStr) ipv4AddrTypeStr = 'IP';
    return ipv4AddrFormatCheck (objArr, ipv4AddrTypeStr, optFlag, alertFlag,
                                prefixStr, suffixStr, octetShowFlag)
    }
function ipv4AddrFormatCheck
    (objArr, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
    {
    var ipOctetMinVal = 0;
    var ipOctetMaxVal = 255;
    var isFirstByteZero = false;
    var isError = false;
    var ipOctetSpecified = false;
    var errMsg = '';
    if (objArr[0].disabled) return true;
    
    for (var i = 0; i < objArr.length; i++)
         {
         if (objArr[i].disabled) break;
         ipOctetMinVal = 0;
         ipOctetMaxVal = 255;
         isError = false;
         var value = objArr[i].value;
         var errMsg = '';
         if (alertFlag)
             {
             if (prefixStr) errMsg = prefixStr;
             errMsg += " Please enter a value between " + ipOctetMinVal +
                       " - " + ipOctetMaxVal + " ";
             if (suffixStr) errMsg += suffixStr;
             }
         if (value.length == 0)
             {
             if (optFlag && !ipOctetSpecified)
                 {
                 continue;
                 }
             var j = 0;
             if (i == 0)
                 {
                  /* check for full empty IP address */
                 for (j = i; j < objArr.length; ++j)
                     {
                     if ((objArr[j].value).length)
                         break;
                      }
                 }
             if (errMsg)
                 {
                 if ((i == 0) && (j == objArr.length) && errMsg)
                     alert ("IP address not specified.\n" + prefixStr +
                            "Please enter a value between " + ipOctetMinVal +
                            " - " + ipOctetMaxVal + " for each octet.");
                 else
                     {
                     if (octetShowFlag) errMsg += (i+1);
                     alert (errMsg);
                     }
                 }
             objArr[i].focus ();
             return false;
             }
         if (optFlag)
             {
             if (i > 0 && !ipOctetSpecified)
                 {
                 if (errMsg)
                     {
                     if (octetShowFlag) errMsg += (i+1);
                     alert (errMsg);
                     }
                 objArr[i].focus ();
                 return false;
                 }
             ipOctetSpecified = true;
             }
/*  
         if (i == 0)
             {
             if (parseInt (value) == 0)
                 {
                 isFirstByteZero = true;
                 continue;
                 }
             ipOctetMinVal = 1;
             }
         if (((i+1) == 4) && (ipv4AddrTypeStr == 'IP'))
             {
//           if (!isFirstByteZero)  ipOctetMinVal = 1;
             ipOctetMaxVal = 254;
             }
*/
         if (((i+1) == 1) && (ipv4AddrTypeStr == 'IP'))
             {
			/*     first octet should not exced 223 */                 
             ipOctetMaxVal = 223;
             }
             
         if (((parseInt (value) > 0) && isFirstByteZero) ||
             (parseInt (value) < ipOctetMinVal || parseInt (value) > ipOctetMaxVal))
             {
             isError = true;
             }
         if (isError)
             {
             if (isFirstByteZero) --i;
             if (alertFlag)
                 {
/*                 if (i == 0)
                     ipOctetMinVal = 1;		*/
                 if (prefixStr) errMsg = prefixStr;
                 errMsg += " Please enter a value between " + ipOctetMinVal +
                           " - " + ipOctetMaxVal + " ";
                 if (suffixStr) errMsg += suffixStr;
                 if (octetShowFlag) errMsg += (i+1);
                 alert (errMsg);
                 }
             objArr[i].focus ();
             return false;
             }
         }
     return true;
     }
     
function ipv4AddrNoZero (ipv4TblId, alertFlag, errMsg)
    {
    if (!ipv4TblId) return false;
    var obj = document.getElementById(ipv4TblId);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    var ipValue = "";
    for (var i = 0; i < objArr.length; i++)
         {
         if (objArr[i].disabled) break;
         ipValue += objArr[i].value;
         }
    if (parseInt (ipValue, 10) <= 0)
         {
         if (alertFlag)
              alert (errMsg);
         return false;
         }
    return true;
    }

/* Converts IP string to an int */
function convert_addr(ipchars) {
    var bytes = ipchars.split('.');
    var result = ((bytes[0] & 0xff) << 24) |
                 ((bytes[1] & 0xff) << 16) |
                 ((bytes[2] & 0xff) <<  8) |
                  (bytes[3] & 0xff);
    return result;
}

/* Converts IP string to an int */
function getIPInt(tblName) {
    var obj = document.getElementById(tblName);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    octet0 =  objArr[0].value;
    octet1 =  objArr[1].value;
    octet2 =  objArr[2].value;
    octet3 =  objArr[3].value  ;

    var result = ((octet0 & 0xff) << 24) |
                 ((octet1 & 0xff) << 16) |
                 ((octet2 & 0xff) <<  8) |
                  (octet3 & 0xff);
    return result;
}

function getIPInt1(srcObjId) {
    if (!srcObjId) return false;
    var obj = document.getElementById(srcObjId);
    if (!obj) return false;
    var ipaddr = obj.value;
    var objArr = ipaddr.split (".");
    if (!objArr.length) return false;
    octet0 =  objArr[0];
    octet1 =  objArr[1];
    octet2 =  objArr[2];
    octet3 =  objArr[3];

    var result = ((octet0 & 0xff) << 24) |
                 ((octet1 & 0xff) << 16) |
                 ((octet2 & 0xff) <<  8) |
                  (octet3 & 0xff);
    return result;
}

/*
 * Compares two IPs and returns
 *  +ve number if Ip1 > IP2,
 *  0 if they are equal
 *  -ve number if IP1 < IP2.
 */

function compareIP(ip1Int, ip2Int) {
    if (ip1Int > ip2Int) return 1;
    if (ip1Int < ip2Int) return -1;
    return 0;
}

function compareIPRange(ip1Int, ip2Int) {
    if ((ip2Int - ip1Int) <= 254) return 1;
    return 0;
}

/* Check an IP (host) falls in a subnet */
function isInSubnet(host, pattern, mask) {
    return (((host & mask) == (pattern & mask)) && !isBroadcastIP(host, pattern, mask)); }

/* Check if an IP (host) is a broadcast IP */
function isBroadcastIP(host, pattern, mask) {
	return ((pattern | ~mask) == host)
}

/*
 * checks if an IP address is in a network.
 * params: ipaddr => IP to be checked (string)
 *         pattern => IP address pattern
 *       maskstr => Subnet mask
 */

function isInSubnetStr(ipaddr, pattern, maskstr) {
    var test = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/(ipaddr);
    if (test == null) {
        ipaddr = 'null'; /* dnsResolve(ipaddr);*/ /*prasanna*/
        if (ipaddr == 'null')
            return false;
    } else if (test[1] > 255 || test[2] > 255 ||
               test[3] > 255 || test[4] > 255) {
        return false;    // not an IP address
    }
    var host = convert_addr(ipaddr);
    var pat  = convert_addr(pattern);
    var mask = convert_addr(maskstr);
    return ((host & mask) == (pat & mask)); }

/* Gets IP address string by cat'ing the 4 octets  */
function getIPStr(tblName)
	{
    var obj = document.getElementById(tblName);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    return '' + objArr[0].value + '.' +
                objArr[1].value + '.' +
                objArr[2].value + '.' +
                objArr[3].value  ;
	}

function getIPStr1(srcObjId)
	{
    if (!srcObjId) return false;
    var obj = document.getElementById(srcObjId);
    if (!obj) return false;
    return obj.value;
	}

function getIPAddrClass (ipAddrArr)
	{
	var initOctet = parseInt (ipAddrArr[0].value, 10);
	if (initOctet >= 0 && initOctet <= 127)
		return 'A';
	if (initOctet >= 128 && initOctet <= 191)
		return 'B';
	if (initOctet >= 192 && initOctet <= 223)
		return 'C';
	return 'D';
	}

var subnetOctets = [0, 128, 192, 224, 240, 248, 252, 254, 255];
function checkSnetMask (snetMaskOctet, stIdx, endIdx)
	{
	if (isNaN (snetMaskOctet)) return true;
	var errorFlag = false;
	for (var i = stIdx; i <= endIdx; i++)
		{
		if (parseInt (snetMaskOctet,10) == subnetOctets[i])
			{
			errorFlag = true;
			break;
			}
		}
	return errorFlag;
	}

function checknetMask (eventObj, srcObj, tableObjId)
	{
    if (!eventObj || !srcObj)
         return false;
    var charUniCode = eventObj.charCode ? eventObj.charCode : eventObj.keyCode;
    /* process only 'tab', '.' keys and space*/
    if (charUniCode != 9 &&
        charUniCode != 110 && charUniCode != 190 &&
        charUniCode != 32)
         return true;

    /* return false if field value is empty */
    if ((srcObj.value).length == 0)
        return true;              

    var obj = document.getElementById(tableObjId);
    var smObjArr = obj.getElementsByTagName("INPUT");
    if (!smObjArr.length) return false;
    for (var i =0; i < smObjArr.length; i++)
        {
        if (smObjArr[i] == srcObj)
            {
            if (i == 0)
                {
                stIdx = 8;
                endIdx = 8;
                break;
                }
            else if (i == 3)
                {
                if (smObjArr[i-1].value != "255" && smObjArr[i-1].value != "")
                    {
                    stIdx = 0;
                    endIdx = 0;
                    break;
                    }
                else
                    {
                    stIdx = 0;
                    endIdx = 6;
                    break;
                    }
                }
            else
                {
                if (smObjArr[i-1].value != "255" && smObjArr[i-1].value != "")
                    {
                    stIdx = 0;
                    endIdx = 0;
                    break;
                    }
                else
                    {
                    stIdx = 0;
                    endIdx = 8;
                    break;
                    }
                }
            }
        }
	if (!(checkSnetMask (srcObj.value, stIdx, endIdx)))
		{
		var errStr = "Invalid subnet mask: Please Enter a value "
		for (var idx = stIdx; idx < endIdx; idx++)
			errStr += subnetOctets[idx] + "/";
		errStr += subnetOctets[endIdx] + ".";			
		alert (errStr);
        srcObj.focus ();
		return false;
		}
		
    /* move focus to next active object if '.' is pressed */
    if (charUniCode == 110 || charUniCode == 190 || charUniCode == 32)
        {
        var nextObj = nextActiveFieldGet (srcObj);
        if (nextObj)
            {
            nextObj.focus ();
            nextObj.select ();
            }
        return false;
        }
    return true;	
	}

function ipSubnetMaskValidate (tblIpAddr,tblSnetMask)
	{
	var errorStr = "";
    if (!tblIpAddr || !tblSnetMask) return false;
    var obj = document.getElementById(tblIpAddr);
    var ipAddrArr = obj.getElementsByTagName("INPUT");
    if (!ipAddrArr.length) return false;
    obj = document.getElementById(tblSnetMask);
    var snetMaskArr = obj.getElementsByTagName("INPUT");
    if (!snetMaskArr.length) return false;
	if (ipAddrArr[0].disabled || snetMaskArr[0].disabled) return true;
	if (parseInt(snetMaskArr[0].value, 10) != 255)
        {
		errorStr += "Invalid subnet mask for octet1: it should be 255 for given class of IP address.";
        snetMaskArr[0].focus ();
        }
	else
		{
		var ipAddrClass = getIPAddrClass (ipAddrArr);
		switch (ipAddrClass)
			{
			case 'A':
					if (checkSnetMask (snetMaskArr[1].value,0,8) == false)
                        {
						errorStr += "Invalid subnet mask for octet2: it should be 0/128/192/224/240/248/252/254/255 for given class of IP address.";
                        snetMaskArr[1].focus ();
                        }
                    else
                        {
                        if (parseInt(snetMaskArr[1].value, 10) == 255)
                            {
							if (checkSnetMask (snetMaskArr[2].value,0,8) == false)
                                {
								errorStr += "Invalid subnet mask for octet3: it should be 0/128/192/224/240/248/252/254/255 for given class of IP address.\n";
                                snetMaskArr[2].focus ();
                                }
							else
								{
								if (parseInt(snetMaskArr[2].value, 10) == 255)
                                    {
									if (checkSnetMask (snetMaskArr[3].value,0,6) == false)
                                        {
										errorStr += "Invalid subnet mask for octet4: it should be 0/128/192/224/240/248/252 for given class of IP address.";
                                        snetMaskArr[3].focus ();
                                        }
                                    }
                                else
                                    {
									if (checkSnetMask(snetMaskArr[3].value,0,0) == false)
                                        {
										errorStr += "Invalid subnet mask for octet4: it should be 0, if octet3 is not equl to 255, for given class of IP address.";
                                        snetMaskArr[3].focus ();
                                        }
                                    }                                
                                }
                            }
                        else
                            {
							if (checkSnetMask (snetMaskArr[2].value,0,0) == false)
                                {
								errorStr += "Invalid subnet mask for octet3: it should be 0, if octet2 is not equl to 255, for given class of IP address.\n";
                                snetMaskArr[2].focus ();
                                }

							else
								{
								if (checkSnetMask (snetMaskArr[3].value,0,0) == false)
                                    {
									errorStr += "Invalid subnet mask for octet4: it should be 0, if octet2 is not equl to 255, for given class of IP address.";
                                    snetMaskArr[3].focus ();
                                    }
								}
                            }
                        }
					break;
			case 'B':
					if (checkSnetMask (snetMaskArr[1].value,8,8) == false)
                        {
						errorStr += "Invalid subnet mask for octet2: it should be 255 for given class of IP address.\n";
                        snetMaskArr[1].focus ();
                        }
					else
						{
						if (checkSnetMask (snetMaskArr[2].value,0,8) == false)
                            {
							errorStr += "Invalid subnet mask for octet3: it should be 0/128/192/224/240/248/252/254/255 for given class of IP address.\n";
                            snetMaskArr[2].focus ();
                            }
						else
							{
                            if (parseInt(snetMaskArr[2].value, 10) == 255)
                                {
    							if (checkSnetMask (snetMaskArr[3].value,0,6) == false)
                                    {
	    							errorStr += "Invalid subnet mask for octet4: it should be 0/128/192/224/240/248/252 for given class of IP address.";
                                    snetMaskArr[3].focus ();
                                    }
                                }
                            else
                                {
    							if (checkSnetMask(snetMaskArr[3].value,0,0) == false)
                                    {
	    							errorStr += "Invalid subnet mask for octet4: it should be 0, if octet3 is not equl to 255, for given class of IP address.";
                                    snetMaskArr[3].focus ();
                                    }
                                }
							}
						}
					break;
			case 'C':
			default:
					if (checkSnetMask (snetMaskArr[1].value,8,8) == false)
                        {
						errorStr += "Invalid subnet mask for octet2: it should be 255 for given class of IP address.\n";
                        snetMaskArr[1].focus ();
                        }
					else
						{
						if (checkSnetMask (snetMaskArr[2].value,0,8) == false)
                            {
							errorStr += "Invalid subnet mask for octet3: it should be 255 for given class of IP address.\n";
                            snetMaskArr[2].focus ();
                            }
						else
							{
							if (checkSnetMask (snetMaskArr[3].value,0,6) == false)
                                {
								errorStr += "Invalid subnet mask for octet4: it should be 0/128/192/224/240/248/252 for given class of IP address.";
                                snetMaskArr[3].focus ();
                                }
							}
						}
			}
		}
	if (errorStr != "")
		{
		alert (errorStr);
		return false;
		}
	return true;		
	}

/* IP Address Range Validate */
function ipRangeValidate (ipAddrStartId, ipAddrEndId)
	{
	var errorFlag = false;	
    if (!ipAddrStartId || !ipAddrEndId) return true;
    var obj = document.getElementById(ipAddrStartId);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return true;
    if (objArr[0].disabled) return true;
	obj = document.getElementById(ipAddrEndId);
    objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return true;
    if (objArr[0].disabled) return true;

    var startIPAddr = getIPStr(ipAddrStartId)
    var endIPAddr = getIPStr(ipAddrEndId)
    var startObjArr = startIPAddr.split (".")
    var endObjArr = endIPAddr.split (".");
    if (startObjArr.length != 4 || endObjArr.length != 4) return true;
	
	/* Check IP Address Octet Range */
	if (ipAddrOctetCheck (startObjArr) == false)
		return true;
		
	if (ipAddrOctetCheck (endObjArr) == false)
		return true;
		
	/* Checking First Octet */
   	var startIpOctet = parseInt (startObjArr[0], 10);
   	var endIpOctet = parseInt (endObjArr[0], 10);
   	if (startIpOctet > endIpOctet)
   		errorFlag = true;
   	else if (startIpOctet == endIpOctet)
		{
   		startIpOctet = parseInt (startObjArr[1], 10);
   		endIpOctet = parseInt (endObjArr[1], 10);
        /* Checking Second Octet */
	   	if (startIpOctet > endIpOctet)
	   		errorFlag = true;
	   	else if (startIpOctet == endIpOctet)
			{
	   		startIpOctet = parseInt (startObjArr[2], 10);
	   		endIpOctet = parseInt (endObjArr[2], 10);
            /* Checking Third Octet */
		   	if (startIpOctet > endIpOctet)
		   		errorFlag = true;
		   	else if (startIpOctet == endIpOctet)
				{
		   		startIpOctet = parseInt (startObjArr[3], 10);
		   		endIpOctet = parseInt (endObjArr[3], 10);
                /* Checking Fourth Octet */
			   	if (startIpOctet > endIpOctet)
			   		errorFlag = true;
				}   					
			}   		
		}
		
	if (errorFlag)
		{
		alert ("End IP address must greater than or equal to the start IP address")
		objArr[0].focus();
		return false;
		}

	return true;
	}
